<?php

if (! isset ( $checkKey ) || $checkKey != 'asfasdfasfasfasf32423424') {
	die ();
}

class compare_class {
	
	var $db;
	var $table_pk;
	var	$exclude_tables;
	var $include_tables;
	var $showDataRowLimit;

	function compare_class($db_host, $db_name, $db_user, $db_pw, $exclude_tables, $include_tables, $showDataRowLimit)
	{					
		$this->exclude_tables   = $exclude_tables;
		$this->include_tables   = $include_tables;
		$this->showDataRowLimit = $showDataRowLimit; 
		
		$this->db = new db_class();
		
		if (! $this->db->connect ( $db_host, $db_user, $db_pw, $db_name, true ))
		{
			$this->db->print_last_error ( false );
			die ( "Could not connect to db" );
		} 
	}
			
	function getTablesRows($compareTableName = 'none', $insert = false, $getSnapshotTableRows = false)
	{								
		if($compareTableName != 'pronux_compare_db_index' && $compareTableName != 'pronux_compare_db_structure')
		{			
			die("wrong compare table: ".$compareTableName);
		}
		
		$this->db->select("OPTIMIZE TABLE `$compareTableName`");
		
		if($insert)
		{
			if (! $this->db->update_sql ( "TRUNCATE TABLE $compareTableName" )) {
				die ( "Could not truncate table $compareTableName" );
			}
		}

		unset($tables);
		if(count($this->include_tables) > 1)
		{			
			foreach($this->include_tables as $value)
			{
				if(!empty($value))
				{
					$tables[$value] = $value;
				}
			}	
		}
		else
		{		
			$r = $this->db->select ( "SHOW TABLES" );
			
			while ( $row = $this->db->get_row ( $r ) ) {				
				$tables [$row [0]] = $row [0];
			}
		}
		
		foreach ( $tables as $tableName )
		{								
			if(in_array($tableName, $this->exclude_tables))
			{
				continue;
			}
					
			if ($getSnapshotTableRows) 
			{
				if($compareTableName == 'pronux_compare_db_structure')
				{					
					$r = $this->db->select ( "SELECT `Table`, `Field`, `Collation`, `Type`, `Null`, `Key`, `Default`, `Extra`, `Privileges` FROM ".$compareTableName);
				}
				else if($compareTableName == 'pronux_compare_db_index')
				{
					$r = $this->db->select ( "SELECT `Table`, `Non_unique`, `Key_name`, `Seq_in_index`, `Column_name`, `Collation`, `Cardinality`, `Sub_part`, `Packed`, `Null`, `Index_type`, `Comment` FROM ".$compareTableName);
				}
				else
				{
					die("wrong table");
				}
			} 
			else if($compareTableName == 'pronux_compare_db_index')
			{
				$r = $this->db->select ( "SHOW INDEX FROM $tableName" );
			} 
			else
			{
				$r = $this->db->select ( "SHOW FULL COLUMNS FROM $tableName" );
			}
			
			while ( $row = $this->db->get_row ( $r, 'MYSQL_ASSOC' ) ) {
				
				if (! $getSnapshotTableRows) {
					$row['Table'] = $tableName;			
				}						
				
				if(in_array($row['Table'], $this->exclude_tables))
				{
					continue;
				}
				
				if(count($this->include_tables) > 1 && !in_array($row['Table'], $this->include_tables))
				{
					continue;
				}
								
				if($insert)
				{					
					$sql = "INSERT INTO $compareTableName SET ";
					foreach($row as $fKey => $fValue)
					{
						$sql .= " `$fKey` = '".mysql_real_escape_string($fValue)."', ";
					}
					
					if(!$this->db->insert_sql(mb_substr($sql,0, -2)))
					{
						die("ERROR: ".$this->db->print_last_error());						
					}
				}

				unset($row['compare_db_index_id']);
				unset($row['compare_db_structure_id']);
				unset($row['date_modified']);
				
				if($compareTableName == 'pronux_compare_db_index')
				{
					$row['row_pk'] = $row['Key_name'];					
				}
				else if($compareTableName == 'pronux_compare_db_structure')
				{
					$row['row_pk'] = $row['Field'];
				}						
								
				$all_rows[$row['Table']][$row['row_pk']] = $row;				
			}
			
			if($getSnapshotTableRows)
			{
				break;
			}			
		}
				
		return $all_rows;
	}
		
	function getCompareInfos()
	{	
		$compare_infos['compare_db_structure']['hasData'] = false;
		$compare_infos['compare_db_structure']['button'] = ' disabled="disabled"';
		$this->db->select("SELECT * FROM pronux_compare_db_structure");		
		if($this->db->row_count > 0)
		{
			$compare_infos['compare_db_structure']['hasData'] = true;
			$compare_infos['compare_db_structure']['button'] = '';
		}
		
		$compare_infos['compare_db_data']['hasData'] = false;
		$compare_infos['compare_db_data']['button'] 	= ' disabled="disabled"';
		$this->db->select("SELECT * FROM pronux_compare_db_data");
		if($this->db->row_count > 0)
		{
			$compare_infos['compare_db_data']['hasData'] = true;
			$compare_infos['compare_db_data']['button'] = '';
		}
				
		return $compare_infos;
	}
	
	function clearCompareTableData(){
		
		if(!empty($this->db->last_error))
		{			
			return;
		}
		
		if (! $this->db->update_sql ( "TRUNCATE TABLE pronux_compare_db_data" )) {
			die ( "Could not truncate tbl pronux_compare_db_structure" );
		}
		
		$table_pk 	= $this->getTablePKs();
		
		$this->getTablesData($table, "insert");						
	}
	
	function getTablesData(&$tables, $mode = "none"){		
			
		if(!empty($this->db->last_error))
		{
			unset($tables);
			return;
		}
					
		$table_pk = $this->getTablePKs();
						
		if(!empty($this->db->last_error))
		{
			unset($tables);
			return;
		}
					
							
		if($mode == 'snapshot')
		{
			$this->db->select("OPTIMIZE TABLE `pronux_compare_db_data`");
			$this->db->last_error = '';
			$r = $this->db->select("SELECT * FROM pronux_compare_db_data ORDER BY `table`, `row_pk`, `compare_db_data_id` asc LIMIT ".$this->showDataRowLimit);
			if(!$r)
			{
				return;
			}
			
			while($data_row = $this->db->get_row($r, 'MYSQL_ASSOC')) {			
				
				if(in_array($data_row['table'], $this->exclude_tables) || (count($this->include_tables) > 1 && !in_array($data_row['table'], $this->include_tables)))
				{
					continue;
				}
				
				//Wurde PK schon gesetzt bei dieser Tabelle
				if(!isset($tables[$data_row['table']][$data_row['row_pk']]['row_pk']))
				{
					$tables[$data_row['table']][$data_row['row_pk']]['row_pk'] = $data_row['row_pk'];				
				}
											
				$tables[$data_row['table']][$data_row['row_pk']][$data_row['field']] = $data_row['value'];
			}
		}
		else
		{	
			unset($tablesToCheck);
			if(count($this->include_tables) > 1)
			{
				foreach($this->include_tables as $value)
				{
					if(!empty($value))
					{
						$tablesToCheck[$value] = $value;
					}
				}				
			}
			else
			{		
				$r = $this->db->select ( "SHOW TABLES" );
				
				while ( $row = $this->db->get_row ( $r ) ) {
					$tablesToCheck [$row [0]] = $row [0];
				}
			}			
								
			$showDataRowLimitCounter = 0;
			$counterStatus = true;
			foreach($tablesToCheck as $tableName)	
			{											
				$rs 	= 0;					
				if(!in_array($tableName, $this->exclude_tables))
				{			
					if(!empty($this->db->last_error))
					{
						unset($tables);
						return;
					}
																			
					$r2 = $this->db->select('SELECT * FROM '.$tableName);	

					if(!empty($this->db->last_error))
					{
						unset($tables);
						return;
					}
										
					while($data_row = $this->db->get_row($r2, 'MYSQL_ASSOC')) {
						
						$rs++;
						
						//Generate PK
						$pk = '';
						foreach($data_row as $fieldName => $fieldValue)
						{		
							if(!isset($table_pk[$tableName]))
							{
								$pk = $rs;
								break;
							}
							else if(in_array($fieldName, $table_pk[$tableName]))
							{
								$pk .= $fieldValue;
							}																
						}
						
						foreach($data_row as $fieldName => $fieldValue)
						{
							if($mode == "insert")
							{
								if(!$this->db->insert_sql("INSERT INTO pronux_compare_db_data SET `table` = '".$tableName."', `row_pk` =  '".mysql_real_escape_string($pk)."', `field` = '".$fieldName."', `value` = '".mysql_real_escape_string($fieldValue)."'"))
								{
									die("ERROR: ".$this->db->print_last_error());						
								}
							}							
								
							//Wurde PK schon gesetzt bei dieser Tabelle
							if(!isset($tables[$tableName][$pk]['row_pk']))						          
							{
								$showDataRowLimitCounter++;
								if($showDataRowLimitCounter > $this->showDataRowLimit)
								{
									$counterStatus = false;
									return $tables;
								}
								$tables[$tableName][$pk]['row_pk'] = $pk;								
							}												
	
							$tables[$tableName][$pk][$fieldName] = $fieldValue;	
						}								
					}					
				}
			}
		}
		
		if(isset($tables))
		{
			return $tables;
		}		
	}
		
	function getTablePKs()
	{
		$table_pk['asdf123asdf']['asdf1234asdf'] = 'asdf1234asdf'; 
		
		if(!empty($this->table_pk))
		{
			return $this->table_pk;
		}
		
		$tables = $this->getTablesRows('pronux_compare_db_structure', false, false);
								
		foreach($tables as $tableName => $myTable)
		{
			foreach($myTable as $fieldValue)
			{								
				if($fieldValue['Key'] == 'PRI')
				{							
					$table_pk[$tableName][$fieldValue['Field']] = $fieldValue['Field'];
				}
			}				
		}
		
		$this->table_pk = $table_pk;
		
		return $table_pk;
	}

	function getSnapshotDate($_POST, $dateFormat = 'eu')	
	{
		$sql = "";
		if (isset ( $_POST ['compare_db_structure'] )) {
			$sql 		= "SELECT * FROM pronux_compare_db_structure ORDER BY compare_db_structure_id DESC LIMIT 1";		
			
		} else if (isset ( $_POST ['compare_db_data'] )) {
			$sql 		= "SELECT * FROM pronux_compare_db_data ORDER BY compare_db_data_id DESC LIMIT 1";
		}
		
		$r 			= $this->db->select ( $sql);
		$row 		= $this->db->get_row($r);
		$d 			= $row ['date_modified'];
		
		if($dateFormat == 'us')
		{
			return mb_substr ( $d, 5, 2 ) . '/' . mb_substr ( $d, 8, 2 ) . '/' . mb_substr ( $d, 0, 4 ) . " - " . mb_substr ( $d, 11, 2 ) . ":" . mb_substr ( $d, 14, 2 ) . ":" . mb_substr ( $d, 17, 2 );
		}
		else
		{
			return mb_substr ( $d, 8, 2 ) . "." . mb_substr ( $d, 5, 2 ) . "." . mb_substr ( $d, 0, 4 ) . " - " . mb_substr ( $d, 11, 2 ) . ":" . mb_substr ( $d, 14, 2 ) . ":" . mb_substr ( $d, 17, 2 );
		}		
	}

	function createCompareTables()
	{				 		
		$this->db->last_error = '';
		if(!$this->db->execute_file('setup/compare_tables.sql'))
		{			
			return $this->db->last_error;
		}	
		return 'created';
	}	

	function createHTML($tableName, $fieldNames, $rows)
	{
		//Start Table			
		$table_html = '<table style="width: 100%">';
		
		//Table Header		
		$table_header = '<tr>';
		$tableNameTemp = 'Table:<span class="style14">.</span>'.$tableName;
					
		$table_header .= '</tr><tr>';
		foreach($fieldNames as $fieldHeaderName)
		{
			$table_header .= '<td>&nbsp;</td>';				
		}
		$table_header .= '</tr><tr>';
					
		foreach($fieldNames as $fieldHeaderName)
		{
			if($tableNameTemp == 'second')
			{
				$tableNameTemp = '';
				continue;
			}
			
			$table_header .= '<td class="style13" colspan="2">'.$tableNameTemp.'</td>';
			
			if($tableNameTemp != '')
			{
				$tableNameTemp = 'second';
			}				
		}
		
		$table_header .= '</tr><tr>';
		
		
		//Table Header Fields
		foreach($fieldNames as $fieldHeaderName)
		{
			$table_header .= '<td class="style8">' . $fieldHeaderName . '</td>';
		}
		$table_header .= '</tr>';					
								
		$table_html .= $table_header;
		
		
		//Rows
		foreach($rows as $key => $value)
		{				
			$table_html .= "<tr>";
			foreach($value as $fieldName => $fieldValue)
			{
				if(in_array($fieldName, $fieldNames))
				{
					$table_html .= $fieldValue;						
				}
			}				
			$table_html .= "</tr>";
		}
					
		$table_html .= '</table>';
		return $table_html;		
	}

	function createHTMLStructure($rows, $allTableFields, $compText)
	{
		$c = 0;
		foreach($allTableFields as $tblField)
		{
			$c++;										
		}
		$table_header  = '<tr><td class="style13" colspan="'.$c.'">&nbsp;</td></tr>';
		$table_header .= '<tr><td class="style13" colspan="'.$c.'">'.$compText.'</td></tr>';
		
		foreach($allTableFields as $tblField)
		{					
			$table_header .= '<td class="style8">' . $tblField . '</td>';										
		}
		
		$table = '<tr>' . $table_header . '</tr>';										
		
		foreach($rows as $no => $row)
		{
			$table .= '<tr>';			
			foreach($row as $fName => $fValue)
			{
				if(in_array($fName, $allTableFields))
				{	
					$table .= $fValue;					
				}
			}	
			$table .= '</tr>';							
		}
		
		return $table;
	}
}
